package com.smppw.analysis.client;

import cn.hutool.core.map.MapUtil;
import cn.hutool.crypto.SignUtil;
import com.smppw.analysis.infrastructure.config.AnalysisProperty;
import com.smppw.common.pojo.ResultVo;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/v1/")
public class TestApi {
    private final AnalysisProperty property;

    public TestApi(AnalysisProperty property) {
        this.property = property;
    }

    /**
     * 生成签名，测试用的
     *
     * @param params 请求参数，包含appKey
     * @return /
     */
    @GetMapping("sign")
    public ResultVo<String> generateSign(@RequestParam Map<String, Object> params) {
        String appKey = MapUtil.getStr(params, "appKey");
        params.entrySet().removeIf(e -> "appKey".equals(e.getKey()));
        List<AnalysisProperty.AppSign> appSigns = this.property.getAppSigns();
        String secret = appSigns.stream().filter(e -> appKey.equalsIgnoreCase(e.getAppKey()))
                .map(AnalysisProperty.AppSign::getAppSecret).findFirst().orElse(null);
        String sign = SignUtil.signParamsMd5(params, secret);
        return ResultVo.ok(sign);
    }
}
