package com.smppw.analysis.infrastructure.config;

import com.smppw.analysis.infrastructure.components.ApiSignInterceptor;
import org.springframework.context.annotation.Configuration;
import org.springframework.lang.NonNull;
import org.springframework.web.servlet.config.annotation.InterceptorRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

@Configuration
public class AnalysisConfig implements WebMvcConfigurer {
    private final AnalysisProperty property;

    public AnalysisConfig(AnalysisProperty property) {
        this.property = property;
    }

    @Override
    public void addInterceptors(@NonNull InterceptorRegistry registry) {
        if (this.property.getEnableSign()) {
            registry.addInterceptor(new ApiSignInterceptor(this.property)).addPathPatterns().excludePathPatterns("/v1/sign");
        }
    }
}
